cpw.mods.fml.common.versioning

## Class ComparableVersion

- java.lang.Object
- - cpw.mods.fml.common.versioning.ComparableVersion

- All Implemented Interfaces:
    Comparable<ComparableVersion>

      public class ComparableVersion
      extends Object
      implements Comparable<ComparableVersion>

  Generic implementation of version comparison.

  Features:

  - mixing of '`-`' (dash) and '`.`' (dot) separators,
  - transition between characters and digits also constitutes a separator: `1.0alpha1 => [1, 0, alpha, 1]`
  - unlimited number of version components,
  - version components in the text can be digits or strings,
  - strings are checked for well-known qualifiers and the qualifier ordering is used for version ordering. Well-known qualifiers (case insensitive) are:
    - `snapshot`
    - `alpha` or `a`
    - `beta` or `b`
    - `milestone` or `m`
    - `rc` or `cr`
    - `(the empty string)` or `ga` or `final`
    - `sp`
    Unknown qualifiers are considered after known qualifiers, with lexical order (always case insensitive),
  - a dash usually precedes a qualifier, and is always less important than something preceded with a dot.
  Author:
    Kenney Westerhof, Hervé Boutemy
  See Also:
    "Versioning" on Maven Wiki

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `ComparableVersion(String version)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `compareTo(ComparableVersion o)`
    `boolean` | `equals(Object o)`
    `int` | `hashCode()`
    `void` | `parseVersion(String version)`
    `String` | `toString()`

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### ComparableVersion

          public ComparableVersion(String version)

  - ### Method Detail

    - #### parseVersion

          public final void parseVersion(String version)

    - #### compareTo

          public int compareTo(ComparableVersion o)

      Specified by:
        `compareTo` in interface `Comparable<ComparableVersion>`

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Object`

    - #### equals

          public boolean equals(Object o)

      Overrides:
        `equals` in class `Object`

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `Object`